// ---rgf, 2003-05-01
// file name:   "XyzType.java"
// compile:     "javac XyzType.java" ... creates "XyzType.class"
// run:         "java XyzType"
// create docs: "javadoc XyzType"

public class XyzType    // example class for demonstrating BSF4Rexx
{
        // constructors of this class (same name as class!)
    public XyzType () {          // constructor without arguments
        counter=counter+1;      // increase counter
    }

    public XyzType (String initialValue) {   // constructor with argument
        this();                 // invoke (call) constructor withou argument
        info=initialValue;      // save initial value
    }
        // keyword "static": class fields (attributes) and class methods
    static public int counter=0;    // will count # of instances

    public static void main (String args[]) {   // start method (function)
        System.out.println("XyzType.main() is invoked, counter="+counter+"...");

        XyzType o = null;    // define a variable of type "XyzType"
        o = new XyzType();   // create an instance of this class and assign it
        System.out.println("counter="+counter+", o.getInfo()="+o.getInfo());
        o.setInfo("Hello, from Java...");
        System.out.println("now o.getInfo()="+o.getInfo());
    }

        // instance fields (attributes) and instance methods
    private String info = null;     // no info per default

    public String getInfo () {  // accessor (getter) method (function)
        return info;            // return whatever "info" points to
    }

    public void setInfo (String aValue) {   // setter method (function)
        info=aValue;            // save received value with "info"
    }
}

