/* ---rgf, 2003-05-01 */
/* environment variable CLASSPATH must also have a dot in it ".", in order to find
   the Java class in the actual directory from which this program is started     */

if rxFuncQuery("BSF") = 1 then   /* BSF() support not loaded yet ? */
do
   call rxFuncAdd "BsfLoadFuncs", "BSF4Rexx", "BsfLoadFuncs"
   call BsfLoadFuncs    /* register the BSF* external functions   */
   call BsfLoadJava     /* load Java, we need it!                 */
end

null=".NIL"             /* representation for Java's "null"       */
javaClass = "XyzType"   /* determine Java class to use            */
   /* query value of static field (attribute) "counter" via class itself */
say "value of static field 'counter'=" || bsf("getStaticValue", javaClass, "counter")
say

   /* creating an instance of the Java class "XyzType"   */
o=BSF("registerBean", null, javaClass)    /* create an instance of "XyzType"     */
say "o:" o
say "# 1:" bsf("invoke", o, "getInfo")    /* get the value via the getter method */
   /* use the object's setter method to define a string value     */
call bsf "invoke", o, "setInfo", "string", "Hello, from Rexx..."
say "# 2:" bsf("invoke", o, "getInfo")    /* get the value via the getter method */
   /* query value of static field (attribute) "counter"  */
say "value of static field 'counter'=" || bsf("getFieldValue", o, "counter")
say

   /* release (unregister) reference to the Java object  */
call BSF "unregisterBean", o              /* remove register entry from Java     */

   /* create a second Java object      */
say "creating another instance of XyzType, this time with an initial value..."
         /* create an instance of "XyzType" and supply a string value   */
o=BSF("registerBean", "otl", javaClass, "String", "Hi, RexxLA!")
say "o:" o
say "# 3:" bsf("invoke", o, "getInfo")    /* get the value via the getter method */
   /* query value of static field (attribute) "counter" via object  */
say "value of static field 'counter'=" || bsf("getFieldValue", o, "counter")

